/*******************************************************************************
* File Name: PO_OLED_RESN.h  
* Version 1.80
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PO_OLED_RESN_H) /* Pins PO_OLED_RESN_H */
#define CY_PINS_PO_OLED_RESN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PO_OLED_RESN_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_80 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 PO_OLED_RESN__PORT == 15 && ((PO_OLED_RESN__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    PO_OLED_RESN_Write(uint8 value) ;
void    PO_OLED_RESN_SetDriveMode(uint8 mode) ;
uint8   PO_OLED_RESN_ReadDataReg(void) ;
uint8   PO_OLED_RESN_Read(void) ;
uint8   PO_OLED_RESN_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PO_OLED_RESN_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PO_OLED_RESN_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PO_OLED_RESN_DM_RES_UP          PIN_DM_RES_UP
#define PO_OLED_RESN_DM_RES_DWN         PIN_DM_RES_DWN
#define PO_OLED_RESN_DM_OD_LO           PIN_DM_OD_LO
#define PO_OLED_RESN_DM_OD_HI           PIN_DM_OD_HI
#define PO_OLED_RESN_DM_STRONG          PIN_DM_STRONG
#define PO_OLED_RESN_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PO_OLED_RESN_MASK               PO_OLED_RESN__MASK
#define PO_OLED_RESN_SHIFT              PO_OLED_RESN__SHIFT
#define PO_OLED_RESN_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PO_OLED_RESN_PS                     (* (reg8 *) PO_OLED_RESN__PS)
/* Data Register */
#define PO_OLED_RESN_DR                     (* (reg8 *) PO_OLED_RESN__DR)
/* Port Number */
#define PO_OLED_RESN_PRT_NUM                (* (reg8 *) PO_OLED_RESN__PRT) 
/* Connect to Analog Globals */                                                  
#define PO_OLED_RESN_AG                     (* (reg8 *) PO_OLED_RESN__AG)                       
/* Analog MUX bux enable */
#define PO_OLED_RESN_AMUX                   (* (reg8 *) PO_OLED_RESN__AMUX) 
/* Bidirectional Enable */                                                        
#define PO_OLED_RESN_BIE                    (* (reg8 *) PO_OLED_RESN__BIE)
/* Bit-mask for Aliased Register Access */
#define PO_OLED_RESN_BIT_MASK               (* (reg8 *) PO_OLED_RESN__BIT_MASK)
/* Bypass Enable */
#define PO_OLED_RESN_BYP                    (* (reg8 *) PO_OLED_RESN__BYP)
/* Port wide control signals */                                                   
#define PO_OLED_RESN_CTL                    (* (reg8 *) PO_OLED_RESN__CTL)
/* Drive Modes */
#define PO_OLED_RESN_DM0                    (* (reg8 *) PO_OLED_RESN__DM0) 
#define PO_OLED_RESN_DM1                    (* (reg8 *) PO_OLED_RESN__DM1)
#define PO_OLED_RESN_DM2                    (* (reg8 *) PO_OLED_RESN__DM2) 
/* Input Buffer Disable Override */
#define PO_OLED_RESN_INP_DIS                (* (reg8 *) PO_OLED_RESN__INP_DIS)
/* LCD Common or Segment Drive */
#define PO_OLED_RESN_LCD_COM_SEG            (* (reg8 *) PO_OLED_RESN__LCD_COM_SEG)
/* Enable Segment LCD */
#define PO_OLED_RESN_LCD_EN                 (* (reg8 *) PO_OLED_RESN__LCD_EN)
/* Slew Rate Control */
#define PO_OLED_RESN_SLW                    (* (reg8 *) PO_OLED_RESN__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PO_OLED_RESN_PRTDSI__CAPS_SEL       (* (reg8 *) PO_OLED_RESN__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PO_OLED_RESN_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PO_OLED_RESN__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PO_OLED_RESN_PRTDSI__OE_SEL0        (* (reg8 *) PO_OLED_RESN__PRTDSI__OE_SEL0) 
#define PO_OLED_RESN_PRTDSI__OE_SEL1        (* (reg8 *) PO_OLED_RESN__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PO_OLED_RESN_PRTDSI__OUT_SEL0       (* (reg8 *) PO_OLED_RESN__PRTDSI__OUT_SEL0) 
#define PO_OLED_RESN_PRTDSI__OUT_SEL1       (* (reg8 *) PO_OLED_RESN__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PO_OLED_RESN_PRTDSI__SYNC_OUT       (* (reg8 *) PO_OLED_RESN__PRTDSI__SYNC_OUT) 


#if defined(PO_OLED_RESN__INTSTAT)  /* Interrupt Registers */

    #define PO_OLED_RESN_INTSTAT                (* (reg8 *) PO_OLED_RESN__INTSTAT)
    #define PO_OLED_RESN_SNAP                   (* (reg8 *) PO_OLED_RESN__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_PO_OLED_RESN_H */


/* [] END OF FILE */
