//*****************************************************************************
//*****************************************************************************
//  FILENAME: LPF2_3.h
//   Version: 4.00, Updated on 2012/9/21 at 11:59:11
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION: C declarations for the LPF2 User Module.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef LPF2_3_INCLUDE
#define LPF2_3_INCLUDE

#include <m8c.h>

#pragma fastcall16 LPF2_3_Start
#pragma fastcall16 LPF2_3_SetPower
#pragma fastcall16 LPF2_3_Stop
#pragma fastcall16 LPF2_3_SetC1
#pragma fastcall16 LPF2_3_SetC2
#pragma fastcall16 LPF2_3_SetC3
#pragma fastcall16 LPF2_3_SetC4
#pragma fastcall16 LPF2_3_SetCA
#pragma fastcall16 LPF2_3_SetCB
#pragma fastcall16 LPF2_3_SetPolarity

//-------------------------------------------------
// Prototypes of the LPF2_3 API.
//-------------------------------------------------

extern void LPF2_3_Start(BYTE bPowerSetting);
extern void LPF2_3_SetPower(BYTE bPowerSetting);
extern void LPF2_3_Stop(void);
extern void LPF2_3_SetC1(BYTE bCapValue);
extern void LPF2_3_SetC2(BYTE bCapValue);
extern void LPF2_3_SetC3(BYTE bCapValue);
extern void LPF2_3_SetC4(BYTE bCapValue);
extern void LPF2_3_SetCA(BYTE bCapValue);
extern void LPF2_3_SetCB(BYTE bCapValue);
extern void LPF2_3_SetPolarity(BYTE bPolaritySetting);

//-------------------------------------------------
// Defines for LPF2_3 API's.
//-------------------------------------------------

#define LPF2_3_OFF                               (0x00)
#define LPF2_3_LOWPOWER                          (0x01)
#define LPF2_3_MEDPOWER                          (0x02)
#define LPF2_3_HIGHPOWER                         (0x03)

#define LPF2_3_FEEDBACK_16                       (0x00)
#define LPF2_3_FEEDBACK_32                       (0x01)

#define LPF2_3_POLARITY_INVERTING                (0x00)
#define LPF2_3_POLARITY_NON_INVERTING            (0x01)

#define LPF2_3_AMD_MSK         (0x70)
#define LPF2_3_AMD_VAL         (0x0)

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------

#pragma ioport  LPF2_3_FLIN_CR0:    0x09c                       //Analog SCA control register 0
BYTE            LPF2_3_FLIN_CR0;
#pragma ioport  LPF2_3_FLIN_CR1:    0x09d                       //Analog SCA control register 1
BYTE            LPF2_3_FLIN_CR1;
#pragma ioport  LPF2_3_FLIN_CR2:    0x09e                       //Analog SCA control register 2
BYTE            LPF2_3_FLIN_CR2;
#pragma ioport  LPF2_3_FLIN_CR3:    0x09f                       //Analog SCA control register 3
BYTE            LPF2_3_FLIN_CR3;
#pragma ioport  LPF2_3_FLOUT_CR0:   0x08c                      //Analog SCB control register 0
BYTE            LPF2_3_FLOUT_CR0;
#pragma ioport  LPF2_3_FLOUT_CR1:   0x08d                      //Analog SCB control register 1
BYTE            LPF2_3_FLOUT_CR1;
#pragma ioport  LPF2_3_FLOUT_CR2:   0x08e                      //Analog SCB control register 2
BYTE            LPF2_3_FLOUT_CR2;
#pragma ioport  LPF2_3_FLOUT_CR3:   0x08f                      //Analog SCB control register 3
BYTE            LPF2_3_FLOUT_CR3;

//  LPF2_3 Cap naming convention per Gregorian and Temes, p293

#pragma ioport  LPF2_3_FILT_C1_REG: 0x09c
BYTE            LPF2_3_FILT_C1_REG;
#pragma ioport  LPF2_3_FILT_C2_REG: 0x09d
BYTE            LPF2_3_FILT_C2_REG;
#pragma ioport  LPF2_3_FILT_C3_REG: 0x08c
BYTE            LPF2_3_FILT_C3_REG;
#pragma ioport  LPF2_3_FILT_C4_REG: 0x09e
BYTE            LPF2_3_FILT_C4_REG;
#pragma ioport  LPF2_3_FILT_CA_REG: 0x09c
BYTE            LPF2_3_FILT_CA_REG;
#pragma ioport  LPF2_3_FILT_CB_REG: 0x08c
BYTE            LPF2_3_FILT_CB_REG;

#pragma ioport  LPF2_3_AMD_REG:     0x166 //Analog Modulator control Register
BYTE            LPF2_3_AMD_REG;

#endif
// end of file LPF2_3.h
